<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="./">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Bstrain step by step &mdash; bstrain  documentation</title>
      <link rel="stylesheet" type="text/css" href="_static/pygments.css?v=80d5e7a1" />
      <link rel="stylesheet" type="text/css" href="_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="_static/mystnb.4510f1fc1dee50b3e5859aac5469c37c29e427902b24a333a5f9fcb2f0b3ac41.css?v=be8a1c11" />
      <link rel="stylesheet" type="text/css" href="_static/copybutton.css?v=76b2166b" />

  
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="_static/jquery.js?v=5d32c60e"></script>
        <script src="_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="_static/documentation_options.js?v=5929fcd5"></script>
        <script src="_static/doctools.js?v=9a2dae69"></script>
        <script src="_static/sphinx_highlight.js?v=dc90522c"></script>
        <script src="_static/clipboard.min.js?v=a7894cd8"></script>
        <script src="_static/copybutton.js?v=f281be69"></script>
        <script async="async" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="author" title="About these documents" href="about.html" />
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Quick guide to Bstrain plotter" href="plotter.html" />
    <link rel="prev" title="How to use" href="howto.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="index.html" class="icon icon-home">
            bstrain
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Bstrain code</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="about.html">About Bstrain</a></li>
<li class="toctree-l1"><a class="reference internal" href="install.html">Install Bstrain</a></li>
<li class="toctree-l1"><a class="reference internal" href="howto.html">How to use</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Bstrain step by step</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#prepare-your-files">Prepare your files</a></li>
<li class="toctree-l2"><a class="reference internal" href="#check-your-results">Check your results</a></li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Bstrain Plotter</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="plotter.html">Quick guide to Bstrain plotter</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">bstrain</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active">Bstrain step by step</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/stepby.md.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="bstrain-step-by-step">
<h1>Bstrain step by step<a class="headerlink" href="#bstrain-step-by-step" title="Link to this heading"></a></h1>
<p>If you want to run Bstrain over your region of interest, here is a step by step guide.</p>
<section id="prepare-your-files">
<h2>Prepare your files<a class="headerlink" href="#prepare-your-files" title="Link to this heading"></a></h2>
<p>1- Crop your data set (2D velocity/displacement field from GNSS or optical correlation) to the region of interest</p>
<p>2- Chose the appropriate cartesian projection minimizing the distorsions for your area, project your data to get lon, lat in km units. If you want to use the plotting utilities from the gitlab repository, chose a UTM projection and note its EPSG code (should be given as -utm option when plotting)</p>
<p>3- Your data should look like a XX columns ascii file containing longitude (km), latitude (km), XX (unused), YY (unused), Veast (mm/yr), err_east (mm/yr), Vnorth (mm/yr), err_north (mm/yr). <strong>Note that uncertainties should be greater than zero</strong>. If not, the code will fail in providing a misfit value that will be NaN. XX and YY should not be empty, we usually let them at 7 8000 values, but these do not affect the code.</p>
<p>4- In your calculation directory, you should have : Regression2D.f90, parameters.in, Makefile, qhull, nn, fmodel*, and lib* files and directories. Regression2D.f90 should only be modified once, to edit the path to the input data file (could be relative path) at line 231 : <code class="code docutils literal notranslate"><span class="pre">open(1,</span> <span class="pre">file='PATH_TO_DATA',</span> <span class="pre">status='old')</span></code></p>
<p>5- Edit the parameters.in file by modifying :
- npointm, the number of stations used, i.e. the size of your input data file (adjust accordingly the ncell_max and ncell_ma that depend on the complexity of the expected signal)
- the size of the box for triangulation (longmin,longmax,latmin,latmax) that should be slightly larger than the data extend
- the size of the box for selecting data (longminda, longmaxda, latminda, latmaxda)
- the size of the box for plotting (longmind, longmaxd, latmind, latmaxd)
- data_amplitude_max if you want to cut data based on their norm
- ratio_init is the number of nodes for the first model set by default to 0.3 (one third of the data) but could be increased or decreased to speed up the convergence.</p>
<p>6- To get a correct run, you need to inform parameters.in with your knowledge of the apriori values that you expect for <span class="math notranslate nohighlight">\(d, \omega, I_2, V_e, V_n\)</span>. The size of each prior must be adjusted to be as close as possible as the expected pattern.
- adjust the apriori on the velocities by chosing the mean of the homogeneous distribution and associated width (theta 1 or 2 depending on the velocity component)
- adjust the maximum and minimum value for tensor invariants (divmin, divmax, etc)</p>
<p>7- If you play with large deformations, you may want to use the Lagrangian definition of the strain rate tensor and then set the variable lagrangian to 1 in parameters.in (see About section)</p>
<p>8- You have to adjust your apriori on the scaling hyperparameter to the uncertainties, called sigma in the parameters.in. If you set sigma_max to 2, it means that you allow Bstrain to multiply by 2 or less the uncertainties given in the dataset. If you believe in your velocity field and uncertainties, we recommend to limit sigma_max to 1.1, i.e no more than 10% of deviation. However, note that this parameter should theoretically be set free, as the Bayesian framework should recover the noise level of the data. By experience, we feel that setting the sigma completely free will give a too smooth results that will not fit correctly the observations. We plan to implement more than one sigma parameter when combining different data sets (one sigma per data set).</p>
<p>9- Adjust the number of iterations (both overall number nsample and burn_in iterations). Keep it small for the first tests to have a complete run first</p>
<p>10- Compile and run !</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>The size of the cubes that will store the PDF is crucial (nvt, nvp and nvd variables in parameters.in) ! nvt and nvp stands for the spatial resolution of your final maps, while nvd stands for the number of bins to sample the PDF. The largest nvd, the better defined are the results and the statistics you will output from the cubes. However, cubes can get very large if nvd is increased too much : be carefull and start with small cubes to get the proper parametrization !
In areas where large contrasts of strain rates are expected, if you sample your PDF over too few bins, you may miss the lowest strain gradients.</p>
</div>
</section>
<section id="check-your-results">
<h2>Check your results<a class="headerlink" href="#check-your-results" title="Link to this heading"></a></h2>
<p>Here are few things you can view to check the quality of the run :</p>
<p>1- Have a look at the mpi.out, check that no NaN values appear in the last runs.</p>
<p>2- run check.py code, and have a look at the VR values that should be high (close to 44% ideally, but anyway should not be lower than 0). Look at the convergence graph to see wether the number of iterations allows for convergence, and if the burn_in is ok. If not, adjust the associated values in parameters.in</p>
<p>3- run plot_compar.py code to have a look at the difference between average, median and maximum mode on some invariants. If the discrepancy is important, for instance average is patchy while median mode is smooth, then convergence is probably not over, or PDF are highly asymetric.</p>
<p>4- You can then check the shape of some PDF by selecting suspicious pixels</p>
<p>5- Carefully look at the maps and results in profile line : maximum mode often still exhibits triangular shapes even if convergence is good. Median and average should not bear triangular shapes anymore. If this is the case, then it may be because of a local outlier (i.e. check the input data set), or because sigma should be higher, or convergence is not over.</p>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="howto.html" class="btn btn-neutral float-left" title="How to use" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="plotter.html" class="btn btn-neutral float-right" title="Quick guide to Bstrain plotter" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, mmetois.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>